﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace QCW
{
    
    public partial class ReadAlarmRecord : Form
    {
        RSComStruct myRSComStruct = new RSComStruct();
        public ReadAlarmRecord()
        {
            InitializeComponent();
        }

        private Boolean GetbitValue(UInt32 input, int index)
        {
            if (index >= sizeof(UInt32) * 8) return false;
            UInt32 value = input << (sizeof(UInt32) * 8 - 1 - index);
            value = value >> (sizeof(UInt32) * 8 - 1);
            if (value > 0) return true;
            else return false;
        }
        private string DispRecord(byte[] RecordPtr)
        {
            string str = null;
            UInt32 ErrType = 0;
            string[] ErrTablle = {"ACDC1 Alarm",
                                 "ACDC2 Alarm",
                                 "FFU Alarm",
                                 "FFU Alarm",
                                 "FFU Alarm",
                                 "FFU Alarm",
                                 "Boost Alarm",
                                 "FFU Alarm",
                                 "CurDRV1 Alarm",
                                 "CurDRV2 Alarm",
                                 "CurDRV3 Alarm",
                                 "CurDRV4 Alarm",
                                 "Laser1 Alarm",
                                 "Laser2 Alarm",
                                 "LaserPower1 Alarm",
                                 "LaserPower2 Alarm",
                                 "TempHigh Alarm",
                                 "TempLow Alarm",
                                 "PulseToolong Alarm",
                                 "MainPower Alarm",
                                 "Duty Alarm",
                                 "ECHO Alarm",
                                 "MainPowerLow Alarm",
                                 "AveragePower too High Alarm",
                                 "FFU4 Alarm",
                                 "FFU4 Alarm",
                                 "FFU4 Alarm",
                                 "FFU4 Alarm",
                                 "FFU4 Alarm",
                                 "FFU4 Alarm",
                                 "FFU4 Alarm",
                                 "FFU4 Alarm",
                                 "FFU4 Alarm",
                                 "FFU4 Alarm",
                                 "FFU4 Alarm",};
            ErrType = RecordPtr[4];
            ErrType <<= 8;
            ErrType += RecordPtr[5];
            ErrType <<= 8;
            ErrType += RecordPtr[6];
            ErrType <<= 8;
            ErrType += RecordPtr[7];
            str += "AlarmTime:";
            str += RecordPtr[0].ToString() + "-";
            str += RecordPtr[1].ToString() + " ";
            str += RecordPtr[2].ToString() + ":";
            str += RecordPtr[3].ToString() + "  :   ";
            for (int i = 0; i < 32; i++)
            {
                if (GetbitValue(ErrType, i))
                {
                    str += ErrTablle[i] + "  ";
                }
            }

            str += ".\r\n";
            return str;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            byte[] Dadabuf = new byte[1000];
            byte[] datainbuf = new byte[1000];
            int datainlen;
            UInt32 uint32t = 0;
            UInt32 ReadLenTotal = 0;
            UInt32 HaveReadedReordLen = 0;
            byte[] mybyte = new byte[4];
            int i = 0;
            mybyte = BitConverter.GetBytes(uint32t);
            Dadabuf[i++] = mybyte[3];
            Dadabuf[i++] = mybyte[2];
            Dadabuf[i++] = mybyte[1];
            Dadabuf[i++] = mybyte[0];
            uint32t = 1;
            mybyte = BitConverter.GetBytes(uint32t);
            Dadabuf[i++] = mybyte[3];
            Dadabuf[i++] = mybyte[2];
            Dadabuf[i++] = mybyte[1];
            Dadabuf[i++] = mybyte[0];
            datainlen = Form1.form1.Mycom.RaycusSend(0xffff, 0x71, Dadabuf, i, ref myRSComStruct); //读取第一条记录
            if (datainlen > 0)
            {
            }
            else
            {
                MessageBox.Show("Communication Timeout");
                return;
            }
            i = 0;
            mybyte[3] = myRSComStruct.RecDada[i++];
            mybyte[2] = myRSComStruct.RecDada[i++];
            mybyte[1] = myRSComStruct.RecDada[i++];
            mybyte[0] = myRSComStruct.RecDada[i++];
            ReadLenTotal = BitConverter.ToUInt32(mybyte, 0);
            mybyte[3] = myRSComStruct.RecDada[i++];
            mybyte[2] = myRSComStruct.RecDada[i++];
            mybyte[1] = myRSComStruct.RecDada[i++];
            mybyte[0] = myRSComStruct.RecDada[i++];
            UInt32 ReadRecordLen = BitConverter.ToUInt32(mybyte, 0);
            HaveReadedReordLen = ReadRecordLen;
            if (ReadRecordLen == 0)
            {
                textBox1.Text = "";
                MessageBox.Show("No Alarm Record");
                return;
            }
            //Dispatcher.Invoke(updatePbDelegate, System.Windows.Threading.DispatcherPriority.Background, new object[] { System.Windows.Controls.ProgressBar.ValueProperty, Convert.ToDouble(ReadRecordLen) });
            textBox1.Text = "";
            for (UInt32 j = 0; j < ReadRecordLen; j++)
            {
                byte[] RecordData = new byte[8];
                Array.Copy(myRSComStruct.RecDada, i, RecordData, 0, 8);
                i += 8;
                textBox1.Text += DispRecord(RecordData);
            }
            while (ReadLenTotal - HaveReadedReordLen > 0)
            {
                i = 0;
                mybyte = BitConverter.GetBytes(HaveReadedReordLen);
                Dadabuf[i++] = mybyte[3];
                Dadabuf[i++] = mybyte[2];
                Dadabuf[i++] = mybyte[1];
                Dadabuf[i++] = mybyte[0];
                mybyte = BitConverter.GetBytes(ReadLenTotal - HaveReadedReordLen);
                Dadabuf[i++] = mybyte[3];
                Dadabuf[i++] = mybyte[2];
                Dadabuf[i++] = mybyte[1];
                Dadabuf[i++] = mybyte[0];
                datainlen = Form1.form1.Mycom.RaycusSend(0xffff, 0x71, Dadabuf, i, ref myRSComStruct); //读取第一条记录
                if (datainlen > 0)
                {
                }
                else
                {
                    MessageBox.Show("Communication Timeout");
                    return;
                }
                i = 0;
                mybyte[3] = myRSComStruct.RecDada[i++];
                mybyte[2] = myRSComStruct.RecDada[i++];
                mybyte[1] = myRSComStruct.RecDada[i++];
                mybyte[0] = myRSComStruct.RecDada[i++];
                ReadLenTotal = BitConverter.ToUInt32(mybyte, 0);
                mybyte[3] = myRSComStruct.RecDada[i++];
                mybyte[2] = myRSComStruct.RecDada[i++];
                mybyte[1] = myRSComStruct.RecDada[i++];
                mybyte[0] = myRSComStruct.RecDada[i++];
                ReadRecordLen = BitConverter.ToUInt32(mybyte, 0);
                for (UInt32 j = 0; j < ReadRecordLen; j++)
                {
                    byte[] RecordData = new byte[8];
                    Array.Copy(myRSComStruct.RecDada, i, RecordData, 0, 8);
                    i += 8;
                    textBox1.Text += DispRecord(RecordData);
                }
                HaveReadedReordLen += ReadRecordLen;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            textBox1.Text = "";
        }
    }
}
